package com.mvp.presenter;

import com.mvp.bean.Error;
import com.mvp.bean.User;
import com.mvp.impl.ILoginListener;
import com.mvp.model.UserModelImpl;
import com.mvp.view.IUserLoginView;

public class UserLoginPresenter {

	UserModelImpl modelImpl;
	IUserLoginView loginView;

	public UserLoginPresenter(IUserLoginView loginView) {
		super();
		this.loginView = loginView;
		modelImpl = new UserModelImpl();
	}

	public void login() {
		loginView.showLoading();
		modelImpl.login(loginView.getUserName(), loginView.getUserPassword(),
				new ILoginListener() {

					@Override
					public void loginSuccessful(User user) {
						// TODO Auto-generated method stub
						loginView.closeLoading();
						loginView.successful(user);
					}

					@Override
					public void loginFailed(Error error) {
						// TODO Auto-generated method stub
						loginView.closeLoading();
						loginView.failed(error);
					}
				});
	}

}
