package com.mvp.ui;

import java.awt.Container;
import java.awt.FlowLayout;
import java.awt.HeadlessException;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPasswordField;
import javax.swing.JProgressBar;
import javax.swing.JTextField;

import com.mvp.bean.Error;
import com.mvp.bean.User;
import com.mvp.presenter.UserLoginPresenter;
import com.mvp.view.IUserLoginView;

public class MainFrame extends JFrame implements ActionListener, IUserLoginView {

	private static final long serialVersionUID = 7408747442747769564L;
	private JTextField textField;
	private JPasswordField passwordField;
	private UserLoginPresenter loginPresenter;
	private JProgressBar bar;

	public MainFrame(String title) throws HeadlessException {
		super(title);
		// TODO Auto-generated constructor stub
		loginPresenter = new UserLoginPresenter(this);
		Container container = getContentPane();
		container.setLayout(new FlowLayout());
		container.add(new JLabel("û"));
		textField = new JTextField("user", 16);
		container.add(textField);
		container.add(new JLabel("     "));
		passwordField = new JPasswordField("123456", 16);
		container.add(passwordField);
		container.add(newJButton("¼"));
		bar = new JProgressBar(JProgressBar.HORIZONTAL);
		container.add(bar);
		bar.setVisible(false);
		bar.setIndeterminate(true);

		setSize(280, 130);
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		setLocationRelativeTo(null);
		setVisible(true);
	}

	private JButton newJButton(String title) {
		JButton button = new JButton(title);
		button.addActionListener(this);
		return button;
	}

	@Override
	public String getUserName() {
		// TODO Auto-generated method stub
		return textField.getText();
	}

	@Override
	public String getUserPassword() {
		// TODO Auto-generated method stub
		return new String(passwordField.getPassword());
	}

	@Override
	public void showLoading() {
		// TODO Auto-generated method stub
		bar.setVisible(true);
	}

	@Override
	public void closeLoading() {
		// TODO Auto-generated method stub
		bar.setVisible(false);
	}

	@Override
	public void successful(User user) {
		// TODO Auto-generated method stub
		System.out.print(user.getName());
		System.out.println(":ϲ¼ɹ");
	}

	@Override
	public void failed(Error error) {
		// TODO Auto-generated method stub
		System.out.print("¼ʧ:");
		System.out.println(error.getMsg());
	}

	@Override
	public void actionPerformed(ActionEvent e) {
		// TODO Auto-generated method stub
		Object obj = e.getSource();
		if (obj instanceof JButton) {
			String str = ((JButton) obj).getText();
			if (str.equals("¼")) {
				loginPresenter.login();
			}
		}
	}

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		// TODO Auto-generated method stub
		new MainFrame("Java MVPģʽʾDemo");
	}

}
